#include <assert.h>
#include <cstring>
#include <cstdlib>
#include <cstdio>
#include <iostream>
#include <algorithm>
#include <set>
#include <vector>
#include <map>

#define FOR(i,a,b) for (int i = int(a); i <= b; i++)
#define DOWN(i,a,b) for (int i = int(a); i >= b; i--)
#define FOREACH(it,c) for (__typeof((c).begin()) it=(c).begin();it!=(c).end();it++)

using namespace std;

int n, m, b[122222], res[122222], Index[122222], a[122222];

struct cmpPair {
  bool operator() (const pair <int, int> & x, const pair <int, int> & y) const {
       if (2 * a[x.first] - a[x.second] != 2 * a[y.first] - a[y.second])
            return (2 * a[x.first] - a[x.second] < 2 * a[y.first] - a[y.second]);

       return x < y;
  }
};

map <int, int> Free;

set <pair <int, int>, cmpPair> S;

bool cmpIndex(int u, int v) {
    return b[u] < b[v];
}

void calc() {
    //sort the array b and keep the original index of each number
    FOR (i, 1, m) Index[i] = i;
    sort(Index + 1, Index + 1 + m, cmpIndex);
    sort(b + 1, b + 1 + m);


    //consider the numbers in sorted array b in the increasing order and pick all numbers x that Free[x] == 0
    //We will mark all the values (2*a[j] - a[i]) (i <= j<= n) as unvalid value
    //But we don't need to consider all value of i and j (from 1 to n).
    //It depends on what is current number in b array that we are consider.
    //More clearly, we mark only the values (2*a[j] - a[i]) (i <= j<= n) that
    //are not larger than the current number in b array that we are consider.
    //using set< pair <int, int> > will help us do this.
    FOR (i, 1, m) {
        while (!S.empty()) {
            pair <int, int> it = *(S.begin());

            if (2 * a[it.first] - a[it.second] > b[Index[i]]) break;

            Free[2 * a[it.first] - a[it.second]] = 1;

            set <pair<int,int> >:: iterator p = S.begin();
            S.erase(p);

            it.second--;
            if (it.second > 0) {
                S.insert(it);

            }

        }

        if (Free[b[i]] == 0) {
            a[++n] = b[i];
            res[n] = Index[i];
            S.insert(make_pair(n, n));
        }
    }
}

int main() {
    cin >> m;
    FOR (i, 1, m) scanf("%d", b + i);

    calc();

    printf("%d\n", n);
    FOR (i, 1, n) printf("%d ", a[i]);
    cout << endl;

    return 0;
}
